<template>
  <div class="card">
    <div>
      <h2>{{ timer }} seconds</h2>
    </div>
    <button
      @click="
        {
          {
            interval ? stop() : start();
          }
        }
      "
      :class="interval ? 'timer-handler active' : 'timer-handler'"
    >
      {{ interval ? "Stop" : timer > 0 ? "Continue" : "Start" }}
    </button>
    <button class="save" v-if="!interval" @click="save">Save</button>
  </div>
</template>

<script>
export default {
  data() {
    return {
      timer: 0,
      interval: null,
    };
  },
  methods: {
    start() {
      this.interval = setInterval(() => this.timer++, 1000);
    },
    stop() {
      clearInterval(this.interval);
      this.interval = null;
    },
    save() {
      this.$emit("save-timer", this.timer);
      this.timer = 0;
    },
  },
  unmounted() {
    if (this.interval) {
      clearInterval(this.interval);
    }
  },
};
</script>

<style scoped>
.card {
  display: grid;
  grid-template-columns: 5fr 1fr 1fr;
  align-items: center;
  gap: 20px;
  padding: 20px;
  margin: 20px 0;
  border-radius: 8px;
  background: #3333eb91;
  color: white;
}

h2 {
  float: left;
}

button {
  color: darkslategrey;
  font-weight: bold;
  padding: 10px;
  border: none;
  border-radius: 8px;
}

.timer-handler {
  background-color: rgb(58, 223, 80);
  color: #4e4e61;
}

.timer-handler.active {
  background-color: rgb(231, 31, 31);
  color: white;
}

.save {
  background-color: rgb(93, 38, 245);
  color: white;
}
</style>
